
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Contract_data_fieldsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const contract_data_fields = await db.contract_data_fields.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        key: data.key
        ||
        null
            ,
            
        value_text: data.value_text
        ||
        null
            ,
            
        value_number: data.value_number
        ||
        null
            ,
            
        value_datetime: data.value_datetime
        ||
        null
            ,
            
        value_boolean: data.value_boolean
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await contract_data_fields.setContract_document( data.contract_document || null, {
            transaction,
        });
        
        await contract_data_fields.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return contract_data_fields;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const contract_data_fieldsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                key: item.key
            ||
            null
            ,
            
                value_text: item.value_text
            ||
            null
            ,
            
                value_number: item.value_number
            ||
            null
            ,
            
                value_datetime: item.value_datetime
            ||
            null
            ,
            
                value_boolean: item.value_boolean
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const contract_data_fields = await db.contract_data_fields.bulkCreate(contract_data_fieldsData, { transaction });

        // For each item created, replace relation files
        

        return contract_data_fields;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const contract_data_fields = await db.contract_data_fields.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.key !== undefined) updatePayload.key = data.key;
        
        
        if (data.value_text !== undefined) updatePayload.value_text = data.value_text;
        
        
        if (data.value_number !== undefined) updatePayload.value_number = data.value_number;
        
        
        if (data.value_datetime !== undefined) updatePayload.value_datetime = data.value_datetime;
        
        
        if (data.value_boolean !== undefined) updatePayload.value_boolean = data.value_boolean;
        
        
        updatePayload.updatedById = currentUser.id;

        await contract_data_fields.update(updatePayload, {transaction});

        
        
        if (data.contract_document !== undefined) {
            await contract_data_fields.setContract_document(
              
              data.contract_document,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await contract_data_fields.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return contract_data_fields;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const contract_data_fields = await db.contract_data_fields.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of contract_data_fields) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of contract_data_fields) {
                await record.destroy({transaction});
            }
        });


        return contract_data_fields;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const contract_data_fields = await db.contract_data_fields.findByPk(id, options);

        await contract_data_fields.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await contract_data_fields.destroy({
            transaction
        });

        return contract_data_fields;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const contract_data_fields = await db.contract_data_fields.findOne(
            { where },
            { transaction },
        );

        if (!contract_data_fields) {
            return contract_data_fields;
        }

        const output = contract_data_fields.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.contract_document = await contract_data_fields.getContract_document({
            transaction
        });
        
        
        output.organizations = await contract_data_fields.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.contract_documents,
        as: 'contract_document',
        
        where: filter.contract_document ? {
          [Op.or]: [
            { id: { [Op.in]: filter.contract_document.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.contract_document.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contract_data_fields',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.key) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contract_data_fields',
                        'key',
                        filter.key,
                    ),
                };
            }
            
            if (filter.value_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contract_data_fields',
                        'value_text',
                        filter.value_text,
                    ),
                };
            }
            

            
            

            
            if (filter.value_numberRange) {
                const [start, end] = filter.value_numberRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    value_number: {
                    ...where.value_number,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    value_number: {
                    ...where.value_number,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.value_datetimeRange) {
                const [start, end] = filter.value_datetimeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    value_datetime: {
                    ...where.value_datetime,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    value_datetime: {
                    ...where.value_datetime,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.value_boolean) {
                where = {
                    ...where,
                value_boolean: filter.value_boolean,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.contract_data_fields.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'contract_data_fields',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.contract_data_fields.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

